import { ObservableLike } from "@reactive-js/observable";
import { Operator } from "@reactive-js/pipe";
import { AsyncEnumerableLike } from "./interfaces";
export declare const enum ReducerRequestType {
    Continue = 1,
    Done = 2
}
export declare type ContinueRequest<TAcc> = {
    readonly type: ReducerRequestType.Continue;
    readonly acc: TAcc;
};
export declare type DoneRequest<TAcc> = {
    readonly type: ReducerRequestType.Done;
    readonly acc: TAcc;
};
export declare type ReducerRequest<TAcc> = ContinueRequest<TAcc> | DoneRequest<TAcc>;
export declare const reduce: <TSrc, TAcc>(reducer: (acc: TAcc, next: TSrc) => ReducerRequest<TAcc>, initial: () => TAcc) => Operator<AsyncEnumerableLike<void, TSrc>, ObservableLike<TAcc>>;
export declare const reduceAsync: <TSrc, TAcc>(reducer: (acc: TAcc, next: TSrc) => ObservableLike<ReducerRequest<TAcc>>, initial: () => TAcc) => Operator<AsyncEnumerableLike<void, TSrc>, ObservableLike<TAcc>>;
